#!/usr/bin/perl
# Copyright (C) 2006 Shigeru Ninagawa
# 1-D 2-state 5-neighbor CA simulator
# with periodic boundary conditons
#    00000 -> 0
# Usage: 125CA.pl rule-file init-file
# rule-file: 31-bit string
# init-file: space separated value

$STEP = 200;

open(RL, $ARGV[0]);
$tmp = <RL>;
close(RL);
chomp($tmp);
@list = split(//,$tmp);
push(@list,0);
@rule = reverse(@list);

#&printrule(@rule);

open(CNF, $ARGV[1]);
$tmp = <CNF>;
close(CNF);
chomp($tmp);
@list = split(" ",$tmp);
$CELLS = @list;
@next = @list;

$outstr = join(" ",@list);
print "$outstr \n";

$step = 1;
while($step < $STEP){
    $next[0] = $rule[$list[$CELLS-2]*16 + $list[$CELLS-1]*8 + $list[0]*4 + $list[1]*2 + $list[2]];
    $next[1] = $rule[$list[$CELLS-1]*16 + $list[$CELLS0]*8 + $list[1]*4 + $list[2]*2 + $list[3]];
    $next[$CELLS-2] = $rule[$list[$CELLS-4]*16 + $list[$CELLS-3]*8 + $list[$CELLS-2]*4 + $list[$CELLS-1]*2 + $list[0]];
    $next[$CELLS-1] = $rule[$list[$CELLS-3]*16 + $list[$CELLS-2]*8 + $list[$CELLS-1]*4 + $list[0]*2 + $list[1]];
    for $i (2..$CELLS-3){
       $next[$i] = $rule[$list[$i-2]*16 + $list[$i-1]*8 + $list[$i]*4 + $list[$i+1]*2 + $list[$i+2]];
    }

    @list = @next;
    $outstr = join(" ",@list);
    print "$outstr \n";

    ++$step;
}

sub printrule {
   $i=31;
   while($i >= 0){
      print "@_[$i]";
      --$i;
   }
   print "\n";
}
