#! /usr/bin/wish -f
#   cav2.tcl
#  2-state cellular automata visualizer
#  Usage:cav2.tcl < space-time-file
set    csize  2;     # pixel size
set    CELL   200;   # no. of cells
set    STEP   200;   # no. of steps
set    dspw  [ expr $csize * $CELL + 2 ]
set    dsph  [ expr $csize * $STEP + 2 ]
frame    .gnd
canvas   .gnd.dsp  -width $dspw -height $dsph
pack     .gnd
pack     .gnd.dsp
set  dx  $csize
set  dy  $csize
set  y1  2 
.gnd.dsp create rectangle 1 1 $dspw $dsph -fill white
gets  stdin  buf
while {![eof stdin]} {
   set cells [split $buf ]
   set x1 2
   foreach i $cells {
      if { $i == 1 } {
         set x2 [ expr $x1 + $dx -1 ]
         set y2 [ expr $y1 + $dy -1 ]
        .gnd.dsp create rectangle $x1 $y1 $x2 $y2 -fill black
      }
      set x1 [ expr $x1 + $dx ]
   }
   set y1 [ expr $y1 + $dy ]
   gets stdin buf
}
