#!/usr/bin/perl
# Copyright (C) 2006 Shigeru Ninagawa
# entropy.pl
# calculate entropy per cell of space-time pattern {0,1}
# Usage: entropy.pl space-time pattern

while(<>){
    push @data, [split];
}

$STEP = @data;
$CELL = @{$data[0]};

$sum = 0;
for( $i = 0; $i < $CELL; ++$i ){
    $dst1 = 0;
    for $t (0..$STEP-1){
       $dst1 += $data[$t][$i];
    }
    $sum += &entropy2($dst1,$STEP);
}

printf("%f\n",$sum/$CELL);

# entropy2(number of 1,total number of data {0,1})
sub entropy2 {
    $res = 0;
    $P1 = $_[0] / $_[1];
    if($P1 > 0 && $P1 < 1){
	$res -= $P1 * log($P1);
    }
    $P0 = 1 - $P1;
    if($P0 > 0 && $P0 < 1){
	$res -= $P0 * log($P0);
    }
    $X = $res / log(2);
}
