#!/usr/bin/perl
# Copyright (C) 2006 Shigeru Ninagawa
# mutual.pl
# calculate mutual information per cell of space-time pattern {0,1}
# Usage: mutual.pl space-time pattern

$DIST=1;

while(<>){
    push @data, [split];
}

$STEP = @data;
$CELL = @{$data[0]};

$sum = 0;
for $i (0..$CELL-1){
   $dst1=0;
   for $t (0..$STEP-1-$DIST){
       $dst1 += $data[$t][$i];
   }
   $mi = &entropy2($dst1,$STEP-$DIST);
   $dst1=0;
   for $t ($DIST..$STEP-1){
       $dst1 += $data[$t][$i];
   }
   $mi += &entropy2($dst1,$STEP-$DIST);

   for $i (0..1){for $j (0..1){$dst[$i][$j]=0;}}
   for $t (0..$STEP-1-$DIST){
       ++$dst[$data[$t][$i]][$data[$t+$DIST][$i]];
   }
   $mi -= &entropy4($dst[0][0],$dst[0][1],$dst[1][0],$dst[1][1]);
#   print"0,0=$dst[0][0] 0,1=$dst[0][1] 1,0=$dst[1][0] 1,1=$dst[1][1]\n";
#   print"mi4=$mi4\n";
   $sum += $mi;
}
printf("%f\n",$sum/$CELL);

# entropy2(number of 1,total number of data {0,1})
sub entropy2 {
    $res = 0;
    $P1 = $_[0] / $_[1];
    if($P1 > 0 && $P1 < 1){
	$res -= $P1 * log($P1);
    }
    $P0 = 1 - $P1;
    if($P0 > 0 && $P0 < 1){
	$res -= $P0 * log($P0);
    }
    $X = $res / log(2);
}

# entropy4(number of A0, num. of A1, num. of A2, num. of A3)
sub entropy4 {
    $res = 0;
    $tot = $_[0] + $_[1] + $_[2] + $_[3];
    for $i (0..3){
	$pd = $_[$i] / $tot;
#	print"pd=$pd\n";
	if($pd > 0 && $pd < 1){
	    $res -= $pd * log($pd);
	}
    }
    $X = $res / log(2);
}
